<?php
/*
Script Name: planet RSS XML feed checker
Script URI: http://planetozh.com/blog/my-projects/planet-rss-xml-ajax-feed-checker/
Description: Checks if feeds aggregated in a 'planet' are valid and still updated
Version: 1.0
Author: Ozh
Author URI: http://planetozh.com/
*/

/********* EDIT BELOW *************/

$ini_file = './config.ini';
	// Path to planet's configuration file
	// Actually, path to any file containing links. The script will detect any URL in it.
	// If left empty, you will be presented a form to paste your link list in


/*******DO NOT EDIT BELOW *********/
/**********************************/


makeheader();


// if there's no ini file hardcoded, let's ask for one
if (!$ini_file) {
	if ($_POST['action'] == 'parse' && $_POST['list']) {
		$content = explode("\n",$_POST['list']);		
	} else {
		makeform();
	}
} else {
	$content = file($ini_file);
}


// valid characters in a url : a-zA-Z0-9-_~,\.\+=/@:!\?$\(\)#
// Finds all URLs mentionned in the file
foreach ($content as $line) {
	if (preg_match('|(https?://[a-zA-Z0-9-_~,\.\+=/@:!\?$\(\)#]+)|',$line,$matches)) {
		$urls[] = $matches[1];
	}
}

if (!is_array($urls) || count($urls) == 0) {
	echo '<p class="notok">No link found. Please retry.</p>';
	makeform();
}

$i=0;
echo "<ol>\n";
foreach ($urls as $url) {
	$i++;
	echo <<<HTML
<li class="li" id="li_$i">
	<div>
		<span class="url" id="url_$i">$url</span>
		<span class="href"> <a href="$url">$url</a> </span>
	</div>
	<div class="wrap" id="wrap_$i">
		<span class="header" id="header_$i"></span>
		<span class="type" id="type_$i"></span>
		<span class="age" id="age_$i"></span>
	</div>
<script>var ajax = new planet($i)</script>
</li>
HTML;
}
echo "</ol>\n";

makefooter();

/************* Some functions *********************/


// Output a form in which you'll paste your links
function makeform() {
	echo <<<HTML
<form method="post">
	<input type="hidden" name="action" value="parse"/>
	<p>Paste your link list, config file, whatever containing URLs here :<br/>
		<textarea rows="20" cols="70" id="list" name="list"></textarea></p>
	<p><input type="submit" value="Submit" /></p>
</form>
HTML;
makefooter();
exit;
}

// Output head of page
function makeheader() {
echo <<<HTML
<html>
	<head>
	<title>planet RSS XML feed checker</title>
	<link rel='stylesheet' href='planet.css' type='text/css'>
	<script src="ajax.js" type="text/javascript"></script
	</head>
<body>
HTML;
}

// Output bottom of page.
function makefooter() {
echo <<<HTML
<div id="byozh"><a href="http://planetozh.com/blog/my-projects/planet-rss-xml-ajax-feed-checker/">planet RSS XML feed checker</a> by <a href="http://planetozh.com/">Ozh</a></div>
</body>
</html>
HTML;
}


?>